#!/usr/bin/env ruby
###########################################################################
###########################################################################
##  Copyright The Resistance (C) 1995-2011                               ##
##  Author: blass                                                        ##
##  blass[at]sdf.lonestar.org                                            ##
##  Badass 0.2 Beta                                                      ##
##  This file is part of Badass.                                         ##
##  Badass is free software: you can redistribute it and/or modify       ##
##  it under the terms of the GNU General Public License as published by ##
##  the Free Software Foundation, either version 3 of the License, or    ##
##  (at your option) any later version.                                  ##
##  Badass is distributed in the hope that it will be useful,            ##
##  but WITHOUT ANY WARRANTY; without even the implied warranty of       ##
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        ##
##  GNU General Public License for more details.                         ##
##  You should have received a copy of the GNU General Public License    ##
##  along with Badass. If not, see http://www.gnu.org/licenses/          ##
###########################################################################
###########################################################################
## This script was based on pentbox 1.4 and re-written by blass          ##
###########################################################################
###########################################################################

# Common procedures and functions.
#

# Is the machine a Windows box?
def iswindows?()
  if RUBY_PLATFORM.downcase.include?("win") != true && RUBY_PLATFORM.downcase.include?("mingw") != true
    return false
  else
    return true
  end
end

# Check if running user are root, or has permission.
def haspermission()
  if !$protected_mode || $protected_mode != true
    return true
  else
    user = ENV["USER"]
    if iswindows?() == false && user == "root"
      return true
    elsif iswindows?() == true
      return true
    else
      return false
    end
  end
end

# Puts and print with colors for Unix-like systems.
def title(string)
  if !$text_color || $text_color != true
    puts string
  elsif iswindows?() == false
    puts "\e[1m\e[40m\e[11m" + string + "\e[0m" # Green, bold, on_black.
  else
    puts string
  end
end
def warning(string)
  if !$text_color || $text_color != true
    print string
  elsif iswindows?() == false
    print "\e[1m\e[31m" + string + "\e[0m" # Red, bold.
  else
    print string
  end
end
# Default gets, command execution implemented.
def gets_pb()
	comm = true
	while comm == true
		ln = gets
		if ln[0] == "!"
			ln[0] = ""
			system(ln.chomp)
			puts "---"
			print "   -> "
			comm = true
		else
			comm = false
			return ln
		end
	end
end

